/*!
 * @file      WorkGroupDlg.h
 * @brief     /׷ â. ˻ âε Ȱ
 * @author    Yangjae.park(yangjae.park@nhn.com)
 * @date      2012-01-25 
 * @warning   
 */
#pragma once

#include "Enum.h"

#include "ChatDlg.h"
#include "NListCtrlEx.h"
#include "MemoSendDlg.h"
#include "OrgTreeData.h"
#include "FavoriteListDlg.h"
#include "FavoriteCreateDlg.h"
#include "InfoSearchWnd.h"
#include "NMImgTabButton.h"
#include "SkinDialog.h"
#include "WorkGroupButtons.h"

//  (ÿ     Ƿ Bit mask )
#define	AUTH_SHOW_NONE			0x00000000
#define	AUTH_SHOW_ORG_TREE		0x00000001 //0000 0000 0000 0000 0001
#define	AUTH_SHOW_WORK_TREE		0x00000002 //0000 0000 0000 0000 0010
#define	AUTH_LEVEL_SEARCH		0x00000004 //0000 0000 0000 0000 0100
#define	AUTH_SHOW_NAME			0x00000010 //0000 0000 0000 0001 0000
#define	AUTH_SHOW_DEPT			0x00000020 //0000 0000 0000 0010 0000
#define	AUTH_SHOW_JBPS			0x00000040 //0000 0000 0000 0100 0000
#define	AUTH_SHOW_JBDT			0x00000080 //0000 0000 0000 1000 0000
#define	AUTH_SHOW_IPT			0x00000100 //0000 0000 0001 0000 0000
#define	AUTH_SHOW_EXT_TEL		0x00000200 //0000 0000 0010 0000 0000 
#define	AUTH_SHOW_CORP_TEL		0x00000400 //0000 0000 0100 0000 0000
#define	AUTH_SHOW_CELL_PH		0x00000800 //0000 0000 1000 0000 0000
#define	AUTH_SHOW_FAX			0x00001000 //0000 0001 0000 0000 0000
#define	AUTH_SHOW_EMAIL			0x00002000 //0000 0010 0000 0000 0000
#define	AUTH_SHOW_ROMNG_PH		0x00004000 //0000 0100 0000 0000 0000
#define	AUTH_SHOW_KEYWORD		0x00008000 //0000 1000 0000 0000 0000
#define	AUTH_SHOW_WORK_PL		0x00010000 //0001 0000 0000 0000 0000
#define AUTH_SHOW_WORK_STATUS	0x00020000 //0010 0000 0000 0000 0000

// Tree X, Y, Width  ̹Ƿ define  
#define POINT_TREE_X			0
#define POINT_TREE_Y			35
#define POINT_LIST_Y			70
#define POINT_PAGE_COMBO_Y		45
#define POINT_PAGE_COMBO_X		199

#define POINT_BTN_PREV_Y		45
#define POINT_BTN_PREV_X		130
#define POINT_BTN_NEXT_X		32

#define DEFAULT_TREE_WIDTH		202
#define MIN_TREE_WIDTH			150
#define MIN_LIST_WIDTH			450

#define ORG_DLG_MIN_X			700			
#define ORG_DLG_MIN_Y			520

#define SEARCH_DLG_MIN_X		700			
#define SEARCH_DLG_MIN_Y		520

#define ID_WORK_SEARCH			(0xE100)

#define PAGE_SIZE				50

typedef std::map<int, int>						GROUP_MEMU_LIST;

class WorkGroupController;
class WorkGroupModel;

class CWorkGroupDlg : public CSkinDialog, 
	private CAMSWnd,
	private CAMSWnd::PlacementHook,
	private IWorkGroupButtonsCallBack,
    private INListCtrlExCallBack
{
public:
	//˾ ޴ ִ (Menu Ǿ ֱ  Ǹ ҽ  Ǿ )
	enum ePOPUP_TYPE
	{
		TREE_POPUP_MENU = 1,
		//WORKGROUP_TREE_MENU = 2,
		LIST_POPUP_MENU = 3
	};

	struct SORTPARAM
	{
		int nSortColumn;
		bool bSortAscending;
		CNListCtrl *pList;
	};

	static int CALLBACK SortFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);

public:
	CWorkGroupDlg(WorkGroupController* pController, WorkGroupModel* pModel, CWnd* pParent = NULL);
	virtual ~CWorkGroupDlg();

	virtual void OnButtonClicked(CWorkGroupButtons::BUTTONS button);
	void	ShowCmd(ORGVIEWTYPE ViewType);
	void	ChangeMyStatus(GTUserStatusType eMyStatus);
	CString GetMemberName(CString strUserID);
	void	__ResourceLoad(BOOL bInit = FALSE);

	DECLARE_DYNAMIC(CWorkGroupDlg)

	BOOL Create(UINT nIDTemplate,CWnd* pParentWnd =NULL );
	BOOL Create(ORGVIEWTYPE eViewType,UINT nIDTemplate,CWnd* pParentWnd = NULL );
	BOOL Create(LPCTSTR pszSearchText, UINT nIDTemplate, CWnd* pParentWnd = NULL);

	void InitOrgGroupTree();
	void InitWorkGroupTree();
	void InitMemberList(bool bIsSearchResult = false);
	void ShowPageControls();

	void UpdateMemberStatus(LPCWSTR strUserId);
	void UpdateMemberIPTStatus(LPCWSTR strUserId);
	void SetReadOnly(BOOL bStatus);
	void RefreshButtonStatus();	//  ¿  ư ¸(Enable/Disable) ٲش

    //INListCtrlExCallBack
    virtual BOOL OnGetItemToolTip(CNListCtrlEx* pThis, int iItem, int iSubItem, CString& strToolTip);

    enum { IDD = IDD_ORG_WORKGROUP };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Դϴ.
	virtual BOOL OnInitDialog();
	void InitTab();
	void InitTreeCtrl();

	
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	virtual BOOL PreTranslateMessage(MSG* pMsg);

	DECLARE_MESSAGE_MAP()

private:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg LRESULT OnNcHitTest(CPoint point);
	afx_msg void OnMnAddFavorite();
	afx_msg void OnMnSendMemo();
	afx_msg void OnMnTreeSendMemo();
	afx_msg void OnMnIMInvite();
	afx_msg void OnMnTreeIMInvite();
	afx_msg void OnMnProfile();
	afx_msg void OnMnCreateFavoriteGroup();
	afx_msg void OnMnChatHistory();
	afx_msg void On_Mn_WrokGroupTree_FavoriteAdd();
	afx_msg void On_Mn_TreeOrg_AddFavorite();

	afx_msg void OnBnClickedShowWorkGroupButton();
	afx_msg void OnBnClickedShowOrgButton();
	afx_msg void OnBnClickedPrevButton();
	afx_msg void OnBnClickedNextButton();
	afx_msg void OnNMRClickList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMRClickTree(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnTvnSelchangedOrgTree(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnTvnSelchangedWorkGroupTree(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnPaint();
	afx_msg BOOL OnEraseBkgnd(CDC *pDC);
	afx_msg void OnMenuTreeFavoriteAdd(WPARAM wParam);
	afx_msg void OnMenuFavoriteButton(WPARAM wParam);
	afx_msg void OnDestroy();
	afx_msg void OnLvnBeginrdragList(NMHDR *pNMHDR, LRESULT *pResult);	
	afx_msg void OnLvnBegindragList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnSize(UINT nType, int cx, int cy);	
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnNcLButtonUp(UINT nHitTest, CPoint point);
	afx_msg void OnGetMinMaxInfo(MINMAXINFO* lpMMI);
	afx_msg void OnLvnItemchangedOrgList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnItemchangedWorkgroupList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnHdnItemclickList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMClickList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnMenuSms();
	afx_msg void OnMenuTreeSms();
	afx_msg void OnNMDblclkList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnCbnSelchangeComboPage();
	afx_msg void OnCbnSelchangeComboLevel();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg LRESULT OnGetBuddyStatus(WPARAM wParam,LPARAM lParam);

	LRESULT OnGetUserStatus(WPARAM wParam,LPARAM lParam);

	void OnBnClickedMemoButton();
	void OnBnClickedChatButton();
	void OnBnClickedFavoriteAddButton();
	void	ReSizeCtrl(void);
	void	FreeTreeItemData(CTreeCtrl *pTreeCtrl, HTREEITEM hItem);
	void	PopupMenuView(int nMain,int nSub);
	void	BeginDrag();
	void	SetUserAuth();
	void	InitLevels();

	void	MakeFavoriteMenu(CMenu* menu, int nSub);
	void	InviteIM();
	void	InitListColumn(CNListCtrl &list, CStringArray &strHeaderTitle, const int *arrWidth);
	void	SendMemo();
	void	SetViewType(ORGVIEWTYPE eViewType);
	void	SetSkin();
	void	DoSearch(CString strSearchText);
	BOOL	HasAuth(DWORD nAuth);	// 2 ̻  ÿ üũϸ ǵ     Ƿ ѹ ϳ Ѹ üũѴ.
	ORGVIEWTYPE GetViewType();
	void	MakeTreeNodes(CTreeCtrl *pTree, const std::vector<GT_ORG_GROUP_DATA>& list);	
	BOOL	IsSelectMyself();
	BOOL	IsAllIdsInBuddyGroup(CStringList &selectedIdList, int nGroupID);
	void	GetSelectedUserIDList(CStringList &selectedIdList);
	bool	IsCloseMsg(MSG* pMsg);
	bool	IsIPPhoneLinkColumn(int nCol);	// IP Phone  ÷ Ǵ
	void	CallToIPT(NE_MEMBER_DATA userData, CString strTel);
	GTUserStatusType	GetUserStatusFromImageIndex(int nIndex);
	void	OnMenuIPT(WPARAM wParam);
	void	MakeTreeChildNode(CTreeCtrl *pTree, HTREEITEM hParentItem, std::multimap<CString, CString> &parentChildMap, std::map<CString, CString> &groupNameMap);
	void	InitListCtrl();
	void	MoveSplitter();
	HTREEITEM FindTreeItem(CTreeCtrl *pTreeCtrl, HTREEITEM hItem, CString strDeptId);
	void	MouseMove(MSG* pMsg, CRect &rcWnd);
	bool	IsWorkStatusColumn(int nCol);
	void	InitPageCtrls();
	BOOL SetUserBottomPNGBK(CString strPath);
	BOOL SetUserBottomPNG(CString strPath);
	void DrawFrame();
	GROUP_MEMU_LIST			m_GroupList;			//޴  ׷ Ʈ <޴ID, ׷ID>

	int m_nAddFavoriteGroupID;		//ģ߰  ׷ ̵. 

	CImageList m_ilStatus;
	CImageList m_ilIPTStatus;
	CImageList m_ilWorkStatus;

	ORGVIEWTYPE m_eViewType;		//  Ÿ(, ׷)
	CChatDlg* m_pChatDlg;			//äâ ȣҰ äâ 
	CMemoSendDlg* m_pSendMemoDlg;	//޸𾲱â ȣ  ޸â 
	UINT _clipBoardFormat;

	COleDataSource _oleDataSource; 	

	// Ʈ Ʈ
	CTreeCtrl m_treeOrg;
	CTreeCtrl m_treeWorkGroup;
	CTreeCtrl *m_pShownTree;		// /׷    ִ Ʈ Ʈ 
	CRect m_rtSplitter;
	bool m_bSplitterClicked;

	// Ʈ Ʈ
	CNListCtrlEx m_lcOrg;
	CNListCtrlEx m_lcWork;
	CNListCtrlEx *m_pShownList;		// /׷    ִ Ʈ Ʈ 

	CNMImgTabButton m_btnORGView;
	CNMImgTabButton m_btnWorkGroupView;
	
	CWorkGroupButtons*	m_pWGButtons;

	CNMImgComboBox	m_comboLevel;
	CNMImgComboBox	m_comboPage;
	CNMImgButton m_btnPrev;
	CNMImgButton m_btnNext;
	bool	m_bIsSearchResult;		//  ǥõǴ  ˻ ƴ
	CString m_strSortCol;
	NE_SEARCH_MEMBER_PARAM m_searchParam;
	int		m_nSearchLevel;
	CString m_strSearchDept;		// ˻ õ μ

	CInfoSearchWnd	m_wndSearch;	// ˻â
	CPen		m_penBorder;
	CBitmap		m_bmTopBg;

	CString m_strSearchText;
	CString m_strSearchCondition;
	DWORD  	m_nUserAuth;			//   ( Ʈ κ   )
	BOOL	m_bTracking;			//  콺 ڽ ִ ƴ  ÷
	WorkGroupController* m_pController;
	WorkGroupModel* m_pModel;
	int m_nCursor;

	int m_nHitTest;
	int m_nBorderHeight;
	int m_nBorderWidth;
	CString m_strPreSelectedFavoriteGroup;
	bool m_bSortAscending;
	ePOPUP_TYPE m_ePopupMenuType;	// Ŭ ޴ Ʈ Ѱ Ʈ   
	bool m_bSelectedBySearchResult;	// Ʈ õ  ڰ  (Ʈ ), ˻   (Ʈ   )

	// Ʈ ׸ ѿ  Show/Hide Ǳ  ÷  Ѵ.
	int m_nColStatus;
	int m_nColName;
	int m_nColDept;
	int m_nColJbps;
	int m_nColJbdt;
	int m_nColIPTPresence;

	int m_nColExtensionTel;
	int m_nColCorpTel;
	int m_nColCellPhone;
	int m_nColFax;
	int m_nColEmail;
	int m_nColRoamingTel;
	int m_nColKeyword;
	int m_nColPlace;
	int m_nColWorkStatus;
	int m_nColUserID;
	int m_nColJbpsCd;
	int m_nColJbdtCd;

	int m_nClickItem;
	int m_nClickSubItem;

	HBITMAP m_hBmpUserBottomBK;
	SIZE	m_sizeUserBottomBK;

	HBITMAP m_hBmpUserBottom;
	SIZE	m_sizeUserBottom;
};

